# Define your item pipelines here
#
# Don't forget to add your pipeline to the ITEM_PIPELINES setting
# See: https://docs.scrapy.org/en/latest/topics/item-pipeline.html


# useful for handling different item types with a single interface
import pymysql as pymysql
from itemadapter import ItemAdapter

from mainTainsouh.items import MaintainsouhItem


class MaintainsouhPipeline:
    def __init__(self):
        self.host = "47.100.68.39"
        self.port = 3310
        self.database = "db_spider"
        self.user = "root"
        self.password = "dip-test"
        self.con = pymysql.connect(host=self.host, port=self.port, database=self.database, user=self.user,
                                   password=self.password)
        self.cu = self.con.cursor()
        print("实例化了数据库")

    def process_item(self, item, spider):
        if isinstance(item, MaintainsouhItem):
            sql_q = 'select id from t_maintain_souh where souh_style_id = "{}"'.format(item['style_id'])
            sql = 'insert into t_maintain_souh (souh_style_id, maintain, price) values ("{}","{}","{}")' \
                .format(item['style_id'], item['maintain_v'], item['reference_price'])
            self.con.ping(reconnect=True)
            self.cu.execute(sql_q)
            if str(self.cu.fetchone()) != 'None':
                return
            self.cu.execute(sql)
            self.con.commit()

    def __del__(self):
        self.cu.close()
        self.con.close()

